/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * OSOYOO Smart Home IoT Blynk Lesson 17B
 * Tutorial URL  https://osoyoo.com/?p=39302
 * CopyRight www.osoyoo.com
 * 
 */
#define BLYNK_PRINT Serial
#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
WidgetLED led0(V0);
WidgetLCD lcd(V2);

// You should get Auth Token in the Blynk App.
 
char server_ip[]="192.168.0.45"; // your local Blynk Server IP address
char auth[] = "******"; // your Blynk Auth token from Blynk APP
 
char ssid[] = "******"; // replace ****** with your network SSID (name)
char pass[] = "******"; // replace ****** with your network password


// or Software Serial on Uno, Nano...
 #include <SoftwareSerial.h>
 SoftwareSerial EspSerial(A9, A8); // RX, TX

// Your ESP8266 baud rate:
#define ESP8266_BAUD 9600

ESP8266 wifi(&EspSerial);
#define whiteLED 9
#define yellowLED 10
#define redLED 11
#define greenLED 12
#define Trig_PIN 25
#define Echo_PIN 26
int period = 1000;
unsigned long time_now = 0;
void setup()
{
  pinMode(redLED, OUTPUT);  // initialize digital pin Red LED as an output.
  pinMode(greenLED, OUTPUT);  // initialize digital pin Red LED as an output.
  pinMode(redLED, OUTPUT);  // initialize digital pin Red LED as an output.
  pinMode(greenLED, OUTPUT);  // initialize digital pin Red LED as an output.
  pinMode(Trig_PIN, OUTPUT);  // initialize digital pin Trig Pin as an output.
  pinMode(Echo_PIN, INPUT);  // initialize digital pin Echo Pin as an input.
  // Debug console
  Serial.begin(9600);

  delay(10);

  // Set ESP8266 baud rate
  EspSerial.begin(ESP8266_BAUD);
  delay(10);

  Blynk.begin(auth, wifi, ssid, pass,server_ip,8080);
}
int watch(){
  long echo_distance;
  digitalWrite(Trig_PIN,LOW);
  delayMicroseconds(5);                                                                              
  digitalWrite(Trig_PIN,HIGH);
  delayMicroseconds(15);
  digitalWrite(Trig_PIN,LOW);
  echo_distance=pulseIn(Echo_PIN,HIGH);
  echo_distance=echo_distance*0.01657; //how far away is the object in cm
  //Serial.println((int)echo_distance);
  return round(echo_distance);
}
void sendSensor()
{
   int distance=watch();
   Blynk.virtualWrite(V1, distance);
   Serial.println(distance);
   if (distance>150) {
    digitalWrite(whiteLED,LOW);  
    digitalWrite(yellowLED,LOW); 
    digitalWrite(redLED,LOW);   
    digitalWrite(greenLED,LOW);    
    Serial.println("No object in range");
    led0.off();
    lcd.clear(); //Use it to clear the LCD Widget
    lcd.print(0, 0, "No object!"); // use: (position X: 0-15, position Y: 0-1, "Message you want to print")
    
   } else  if (distance>30)
   {
    Serial.println("Object detected");
    lcd.clear(); //Use it to clear the LCD Widget
    lcd.print(0, 0, "Object detected"); // use: (position X: 0-15, position Y: 0-1, "Message you want to print")
    digitalWrite(whiteLED,LOW);  
    digitalWrite(yellowLED,LOW); 
    digitalWrite(redLED,HIGH);  
    digitalWrite(greenLED,LOW);   
    led0.on();
 
    
   }
   else  if (distance>15)
   {
    Serial.println("Object is far!");
    digitalWrite(whiteLED,LOW);  
    digitalWrite(yellowLED,LOW); 
    digitalWrite(redLED,LOW);   
    digitalWrite(greenLED,HIGH);   
    led0.on();
    lcd.clear(); //Use it to clear the LCD Widget
    lcd.print(0, 0, "Object is far!"); // use: (position X: 0-15, position Y: 0-1, "Message you want to print")
   }else  if (distance>10)
   {
    Serial.println("Object is near!");
    digitalWrite(whiteLED,LOW);  
    digitalWrite(yellowLED,HIGH); 
    digitalWrite(redLED,LOW);   
    digitalWrite(greenLED,LOW);   
    lcd.clear(); //Use it to clear the LCD Widget
    lcd.print(0, 0, "Object is near!");
  
   } else 
   {
    Serial.println("Object very near!");
    digitalWrite(whiteLED,HIGH);  
    digitalWrite(yellowLED,LOW); 
    digitalWrite(redLED,LOW);   
    digitalWrite(greenLED,LOW);   
    led0.on();
    lcd.clear(); //Use it to clear the LCD Widget
    lcd.print(0, 0, "Object very near!");

  }
}

void loop()
{
  Blynk.run();
  if(millis() >= time_now + period){
        time_now += period;
        sendSensor();
  }
 
}
